"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getCommands = exports.readCsv = void 0;
const fs = __importStar(require("fs"));
const parseCsv = require('csv-parse/lib/sync');
function readCsv(dataFile) {
    return __awaiter(this, void 0, void 0, function* () {
        let rawData = fs.readFileSync(dataFile, "utf8");
        const parsed = parseCsv(rawData, {
            columns: true,
            skip_empty_lines: true,
            delimiter: ';',
            skip_records_with_error: false
        }).map((it, i) => {
            return {
                nodeId: it["node"],
                startTime: it["start"],
                endTime: it["end"],
                vaultNum: it["vault"],
                amount: it["amount"],
                fileName: it["file name"],
            };
        });
        return parsed;
    });
}
exports.readCsv = readCsv;
function getCommands(dataFile) {
    return __awaiter(this, void 0, void 0, function* () {
        let data = yield readCsv(dataFile);
        let commands = [];
        for (let obj of data) {
            let c1 = `bin/flare-stake-tool transaction delegate -n ${obj.nodeId} --amount ${obj.amount.replace(/\B(?=(\d{3})+(?!\d))/g, ",")} --start-time ${obj.startTime} --end-time ${obj.endTime} -i ${obj.fileName} --ctx-file ctx${obj.vaultNum}.json`;
            let c2 = `bin/flare-stake-tool forDefi sign -i ${obj.fileName} --ctx-file ctx${obj.vaultNum}.json`;
            let c3 = `bin/flare-stake-tool forDefi fetch -i ${obj.fileName} --ctx-file ctx${obj.vaultNum}.json`;
            let c4 = `bin/flare-stake-tool send -i ${obj.fileName} --ctx-file ctx${obj.vaultNum}.json`;
            commands.push({
                c1: c1,
                c2: c2
            });
        }
        let generatedJSON = JSON.stringify(commands, null, 2);
        fs.writeFileSync(`generated-commands.json`, generatedJSON, "utf8");
    });
}
exports.getCommands = getCommands;
getCommands("data.csv");
