"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.derivationModeConstants = exports.walletConstants = exports.networkConstants = exports.taskConstants = void 0;
const chalk_1 = __importDefault(require("chalk"));
/**
 * @description Object that constains list of tasks user can perform as its keys and their corresponding CLI commands as values.
 */
exports.taskConstants = {
    'View chain addresses': 'addresses',
    'Check on-chain balance': 'balance',
    'Get network info': 'network',
    'Get validator info': 'validators',
    'Move assets from C-chain to P-chain': 'CP',
    'Move assets from P-chain to C-chain': 'PC',
    'Add a validator node': 'stake',
    'Delegate to a validator node': 'delegate',
    'Get Mirror fund details': 'mirror',
    'Claim Rewards': "rewards",
    'Withdraw funds': 'withdrawal',
    'Import Funds (incase moving assets fails for either P chain or C chain)': 'import',
    'Optout of Airdrop': 'optout',
    'Quit': 'quit'
};
/**
 * @description Constant object which contains the supported networks and their corresponding formatted output names as key-value pairs.
 */
exports.networkConstants = {
    "flare": "Flare " + chalk_1.default.green("(mainnet)"),
    "songbird": "Songbird " + chalk_1.default.green("(canary)"),
    "costwo": "Coston2 " + chalk_1.default.yellow("(testnet)"),
    "coston": "Coston" + chalk_1.default.yellow("(testnet)"),
    "localflare": "LocalHost " + chalk_1.default.red("(devnet)"),
};
/**
 * @description Constant object which contains the supported wallets and their corresponding formatted output names as key-value pairs.
 */
exports.walletConstants = {
    "ledger": 'Ledger',
    "publicKey": 'Public Key',
    "privateKey": "Private Key " + chalk_1.default.red("(not recommended!)")
};
/**
 * @description Constant object which contains the supported wallet derivation path modes and their corresponding formatted output names as key-value pairs.
 */
exports.derivationModeConstants = {
    "bip44": 'BIP44 (Default)',
    "ledger_live": 'Ledger Live',
};
