"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.waitFinalize = exports.delegationAddressCount = exports.isAlreadySentToChain = exports.addFlagForSentSignedTx = exports.readSignedTxJson = exports.readUnsignedTxJson = exports.saveUnsignedTxJson = exports.initCtxJson = exports.deserializeUnsignedTx = exports.serializeUnsignedTx = exports.deserializeImportPC_args = exports.serializeImportPC_args = exports.deserializeExportCP_args = exports.serializeExportCP_args = exports.toBN = exports.parseRelativeTime = exports.integerToDecimal = exports.decimalToInteger = exports.prefix0x = exports.unPrefix0x = exports.sleepms = exports.expandSignature = exports.recoverPublicKey = exports.recoverTransactionSigner = exports.recoverMessageSigner = exports.validatePublicKey = exports.publicKeyToEthereumAddressString = exports.publicKeyToBech32AddressString = exports.publicKeyToBech32AddressBuffer = exports.compressPublicKey = exports.decodePublicKey = exports.privateKeyToPublicKey = exports.privateKeyToEncodedPublicKey = void 0;
const fs_1 = __importDefault(require("fs"));
const ethutil = __importStar(require("ethereumjs-util"));
const elliptic = __importStar(require("elliptic"));
const bech32_1 = require("bech32");
const dist_1 = require("@flarenetwork/flarejs/dist");
const utils_1 = require("@flarenetwork/flarejs/dist/utils");
const evm_1 = require("@flarenetwork/flarejs/dist/apis/evm");
const forDefi_1 = require("./constants/forDefi");
//////////////////////////////////////////////////////////////////////////////////////////
// public keys and bech32 addresses
const ec = new elliptic.ec("secp256k1");
function privateKeyToEncodedPublicKey(privateKey, compress = true) {
    const keyPair = ec.keyFromPrivate(privateKey);
    return keyPair.getPublic().encode("hex", compress);
}
exports.privateKeyToEncodedPublicKey = privateKeyToEncodedPublicKey;
function privateKeyToPublicKey(privateKey) {
    const keyPair = ec.keyFromPrivate(privateKey).getPublic();
    const x = keyPair.getX().toBuffer(undefined, 32);
    const y = keyPair.getY().toBuffer(undefined, 32);
    return [x, y];
}
exports.privateKeyToPublicKey = privateKeyToPublicKey;
function decodePublicKey(publicKey) {
    publicKey = unPrefix0x(publicKey);
    if (publicKey.length == 128) {
        publicKey = "04" + publicKey;
    }
    const keyPair = ec.keyFromPublic(publicKey, 'hex').getPublic();
    const x = keyPair.getX().toBuffer(undefined, 32);
    const y = keyPair.getY().toBuffer(undefined, 32);
    return [x, y];
}
exports.decodePublicKey = decodePublicKey;
function compressPublicKey(x, y) {
    return Buffer.from(ec.keyFromPublic({
        x: x.toString('hex'),
        y: y.toString('hex')
    }).getPublic().encode("hex", true), "hex");
}
exports.compressPublicKey = compressPublicKey;
function publicKeyToBech32AddressBuffer(x, y) {
    const compressed = compressPublicKey(x, y);
    return ethutil.ripemd160(ethutil.sha256(compressed), false);
}
exports.publicKeyToBech32AddressBuffer = publicKeyToBech32AddressBuffer;
function publicKeyToBech32AddressString(publicKey, hrp) {
    const [pubX, pubY] = decodePublicKey(publicKey);
    const addressBuffer = publicKeyToBech32AddressBuffer(pubX, pubY);
    return `${bech32_1.bech32.encode(hrp, bech32_1.bech32.toWords(addressBuffer))}`;
}
exports.publicKeyToBech32AddressString = publicKeyToBech32AddressString;
function publicKeyToEthereumAddressString(publicKey) {
    const [pubX, pubY] = decodePublicKey(publicKey);
    const decompressedPubk = Buffer.concat([pubX, pubY]);
    const ethAddress = ethutil.publicToAddress(decompressedPubk);
    return prefix0x(ethAddress.toString('hex'));
}
exports.publicKeyToEthereumAddressString = publicKeyToEthereumAddressString;
function validatePublicKey(publicKey) {
    try {
        decodePublicKey(publicKey);
        return true;
    }
    catch (error) {
        return false;
    }
}
exports.validatePublicKey = validatePublicKey;
/////////////////////////////////////////////////////////////////////////////////////////
// signatures
function recoverMessageSigner(message, signature) {
    const messageHash = ethutil.hashPersonalMessage(message);
    return recoverTransactionSigner(messageHash, signature);
}
exports.recoverMessageSigner = recoverMessageSigner;
function recoverTransactionSigner(message, signature) {
    let split = ethutil.fromRpcSig(signature);
    let publicKey = ethutil.ecrecover(message, split.v, split.r, split.s);
    let signer = ethutil.pubToAddress(publicKey).toString("hex");
    return signer;
}
exports.recoverTransactionSigner = recoverTransactionSigner;
function recoverPublicKey(message, signature) {
    const split = ethutil.fromRpcSig(signature);
    return ethutil.ecrecover(message, split.v, split.r, split.s);
}
exports.recoverPublicKey = recoverPublicKey;
function expandSignature(signature) {
    let recoveryParam = parseInt(signature.slice(128, 130), 16);
    if (recoveryParam === 27 || recoveryParam === 28)
        recoveryParam -= 27;
    return {
        r: new dist_1.BN(signature.slice(0, 64), 'hex'),
        s: new dist_1.BN(signature.slice(64, 128), 'hex'),
        recoveryParam: recoveryParam
    };
}
exports.expandSignature = expandSignature;
//////////////////////////////////////////////////////////////////////////////////////////
// general helper functions
function sleepms(milliseconds) {
    return __awaiter(this, void 0, void 0, function* () {
        yield new Promise((resolve) => {
            setTimeout(() => {
                resolve();
            }, milliseconds);
        });
    });
}
exports.sleepms = sleepms;
function unPrefix0x(tx) {
    if (!tx) {
        return '0x0';
    }
    return tx.startsWith('0x') ? tx.slice(2) : tx;
}
exports.unPrefix0x = unPrefix0x;
function prefix0x(hexString) {
    if (!hexString) {
        return '0x0';
    }
    return hexString.startsWith("0x") ? hexString : "0x" + unPrefix0x(hexString);
}
exports.prefix0x = prefix0x;
function decimalToInteger(dec, offset) {
    let ret = dec;
    if (ret.includes('.')) {
        const split = ret.split('.');
        ret = split[0] + split[1].slice(0, offset).padEnd(offset, '0');
    }
    else {
        ret = ret + '0'.repeat(offset);
    }
    return ret;
}
exports.decimalToInteger = decimalToInteger;
function integerToDecimal(int, offset) {
    if (int === '0') {
        return '0';
    }
    int = int.padStart(offset, '0');
    const part1 = int.slice(0, -offset) || "0";
    const part2 = int.slice(-offset).replace(/0+$/, '');
    return part1 + (part2 === "" ? "" : '.' + part2);
}
exports.integerToDecimal = integerToDecimal;
function parseRelativeTime(time) {
    // assume time starts with now+
    return (0, utils_1.UnixNow)().add(new dist_1.BN(time.split('+')[1])).toString();
}
exports.parseRelativeTime = parseRelativeTime;
function toBN(num) {
    return num ? new dist_1.BN(num) : undefined;
}
exports.toBN = toBN;
//////////////////////////////////////////////////////////////////////////////////////////
// serialization of atomic c-chain addresses does not work correctly, so we have to improvise
function serializeExportCP_args(args) {
    return JSON.stringify(args, null, 2);
}
exports.serializeExportCP_args = serializeExportCP_args;
function deserializeExportCP_args(serargs) {
    const args = JSON.parse(serargs);
    [0, 7, 9].map(i => args[i] = new dist_1.BN(args[i], 16));
    return args;
}
exports.deserializeExportCP_args = deserializeExportCP_args;
function serializeImportPC_args(args) {
    return JSON.stringify([args[0].serialize('hex'), ...args.slice(1)], null, 2);
}
exports.serializeImportPC_args = serializeImportPC_args;
function deserializeImportPC_args(serargs) {
    const args = JSON.parse(serargs);
    const utxoSet = new evm_1.UTXOSet();
    utxoSet.deserialize(args[0]);
    args[0] = utxoSet;
    args[5] = new dist_1.BN(args[5], 16);
    return args;
}
exports.deserializeImportPC_args = deserializeImportPC_args;
function serializeUnsignedTx(unsignedTx) {
    return JSON.stringify(unsignedTx.serialize("hex"), null, 2);
}
exports.serializeUnsignedTx = serializeUnsignedTx;
function deserializeUnsignedTx(type, serialized) {
    const unsignedTx = new type();
    unsignedTx.deserialize(JSON.parse(serialized));
    return unsignedTx;
}
exports.deserializeUnsignedTx = deserializeUnsignedTx;
//////////////////////////////////////////////////////////////////////////////////////////
// key and unsigned/signed transaction storage
function initCtxJson(contextFile) {
    if (fs_1.default.existsSync('ctx.json')) {
        throw new Error('ctx.json already exists');
    }
    fs_1.default.writeFileSync('ctx.json', JSON.stringify(contextFile, null, 2));
}
exports.initCtxJson = initCtxJson;
function saveUnsignedTxJson(unsignedTxJson, id, dir) {
    if (dir === undefined)
        dir = `${forDefi_1.forDefiDirectory}/${forDefi_1.forDefiUnsignedTxnDirectory}`;
    fs_1.default.mkdirSync(dir, { recursive: true });
    const fname = `${dir}/${id}.unsignedTx.json`;
    if (fs_1.default.existsSync(fname)) {
        throw new Error(`unsignedTx file ${fname} already exists`);
    }
    const forDefiHash = Buffer.from(unsignedTxJson.signatureRequests[0].message, 'hex').toString('base64');
    const unsignedTxJsonForDefi = Object.assign(Object.assign({}, unsignedTxJson), { forDefiHash: forDefiHash });
    const serialization = JSON.stringify(unsignedTxJsonForDefi, null, 2);
    fs_1.default.writeFileSync(fname, serialization);
}
exports.saveUnsignedTxJson = saveUnsignedTxJson;
function readUnsignedTxJson(id) {
    const fname = `${forDefi_1.forDefiDirectory}/${forDefi_1.forDefiUnsignedTxnDirectory}/${id}.unsignedTx.json`;
    if (!fs_1.default.existsSync(fname)) {
        throw new Error(`unsignedTx file ${fname} does not exist`);
    }
    const serialization = fs_1.default.readFileSync(fname, 'utf-8').toString();
    return JSON.parse(serialization);
}
exports.readUnsignedTxJson = readUnsignedTxJson;
function readSignedTxJson(id) {
    const fname = `${forDefi_1.forDefiDirectory}/${forDefi_1.forDefiSignedTxnDirectory}/${id}.signedTx.json`;
    if (!fs_1.default.existsSync(fname)) {
        throw new Error(`signedTx file ${fname} does not exist`);
    }
    const serialization = fs_1.default.readFileSync(fname).toString();
    const resp = JSON.parse(serialization);
    if (!resp.signature) {
        throw new Error(`unsignedTx file ${fname} does not contain signature`);
    }
    return resp;
}
exports.readSignedTxJson = readSignedTxJson;
/**
 * @description Adds a flag to the signed txn to indicate it has been submitted to the blockchain
 * @param {string} id Transaction Id used to create the transaction file
 */
function addFlagForSentSignedTx(id) {
    const fname = `${forDefi_1.forDefiDirectory}/${forDefi_1.forDefiSignedTxnDirectory}/${id}.signedTx.json`;
    if (!fs_1.default.existsSync(fname)) {
        throw new Error(`signedTx file ${fname} does not exist`);
    }
    const serialization = fs_1.default.readFileSync(fname).toString();
    const txObj = JSON.parse(serialization);
    txObj.isSentToChain = true;
    fs_1.default.writeFileSync(`${forDefi_1.forDefiDirectory}/${forDefi_1.forDefiSignedTxnDirectory}/${id}.signedTx.json`, JSON.stringify(txObj), "utf8");
}
exports.addFlagForSentSignedTx = addFlagForSentSignedTx;
/**
 * @description Checks whether the transaction has already been submitted to the blockchain
 * @param {string} id Transaction Id used to create the transaction file
 * @returns {boolean}
 */
function isAlreadySentToChain(id) {
    const fname = `${forDefi_1.forDefiDirectory}/${forDefi_1.forDefiSignedTxnDirectory}/${id}.signedTx.json`;
    if (!fs_1.default.existsSync(fname)) {
        return false;
    }
    const serialization = fs_1.default.readFileSync(fname).toString();
    const txObj = JSON.parse(serialization);
    return txObj.isSentToChain ? true : false;
}
exports.isAlreadySentToChain = isAlreadySentToChain;
//////////////////////////////////////////////////////////////////////////////////////////
// limiting delegation number
function countpAddressInDelegation(validators, pAddressBech32) {
    let count = 0;
    const validatorNodeIds = [];
    for (const item of validators) {
        if (item.delegators) {
            for (const delegator of item.delegators) {
                for (const addr of delegator.rewardOwner.addresses) {
                    if (addr.toLowerCase() === pAddressBech32.toLowerCase()) {
                        count++;
                        validatorNodeIds.push(item.nodeID.toLowerCase());
                    }
                }
            }
        }
    }
    return { count, validatorNodeIds };
}
/**
 * @description Count number of p-chain address used for delegation
 * @param {Context} ctx context file
 * @returns number of times p address used in current validators delegation list
 */
function delegationAddressCount(ctx) {
    return __awaiter(this, void 0, void 0, function* () {
        const current = yield ctx.pchain.getCurrentValidators();
        const pending = yield ctx.pchain.getPendingValidators();
        const pendingValidtaor = JSON.parse(JSON.stringify(pending));
        const pCurrent = JSON.parse(JSON.stringify(current));
        const currentDelegationDetails = countpAddressInDelegation(pCurrent.validators, ctx.pAddressBech32);
        const pendingDelegationDetails = countpAddressInDelegation(pendingValidtaor.validators, ctx.pAddressBech32);
        return { count: currentDelegationDetails.count + pendingDelegationDetails.count, validatorNodeId: [...currentDelegationDetails.validatorNodeIds, ...pendingDelegationDetails.validatorNodeIds] };
    });
}
exports.delegationAddressCount = delegationAddressCount;
//////////////////////////////////////////////////////////////////////////////////////////
// finalization
function waitFinalize(ctx, prms) {
    return __awaiter(this, void 0, void 0, function* () {
        const txcount1 = yield ctx.web3.eth.getTransactionCount(ctx.cAddressHex);
        const resp = yield prms;
        while ((yield ctx.web3.eth.getTransactionCount(ctx.cAddressHex)) == txcount1) {
            yield sleepms(1000);
        }
        return resp;
    });
}
exports.waitFinalize = waitFinalize;
